crashpad::MinidumpCrashpadInfoWriter Class Referencefinal

The writer for a MinidumpCrashpadInfo stream in a minidump file. More...

`#include "minidump/minidump_crashpad_info_writer.h"`

Inheritance diagram for crashpad::MinidumpCrashpadInfoWriter:

## Public Member Functions

void | InitializeFromSnapshot (const ProcessSnapshot *process_snapshot)
| Initializes MinidumpCrashpadInfo based on process_snapshot. More...
void | SetReportID (const UUID &report_id)
| Sets MinidumpCrashpadInfo::report_id.
void | SetClientID (const UUID &client_id)
| Sets MinidumpCrashpadInfo::client_id.
void | SetSimpleAnnotations (std::unique_ptr< MinidumpSimpleStringDictionaryWriter > simple_annotations)
| Arranges for MinidumpCrashpadInfo::simple_annotations to point to the MinidumpSimpleStringDictionaryWriter object to be written by simple_annotations. More...
void | SetModuleList (std::unique_ptr< MinidumpModuleCrashpadInfoListWriter > module_list)
| Arranges for MinidumpCrashpadInfo::module_list to point to the MinidumpModuleCrashpadInfoList object to be written by module_list. More...
bool | IsUseful () const
| Determines whether the object is useful. More...
Public Member Functions inherited from crashpad::internal::MinidumpStreamWriter
const MINIDUMP_DIRECTORY * | DirectoryListEntry () const
| Returns a MINIDUMP_DIRECTORY entry that serves as a pointer to this stream. More...
Public Member Functions inherited from crashpad::internal::MinidumpWritable
virtual bool | WriteEverything (FileWriterInterface *file_writer)
| Writes an object and all of its children to a minidump file. More...
void | RegisterRVA (RVA *rva)
| Registers a file offset pointer as one that should point to the object on which this method is called. More...
void | RegisterLocationDescriptor (MINIDUMP_LOCATION_DESCRIPTOR *location_descriptor)
| Registers a location descriptor as one that should point to the object on which this method is called. More...

## Protected Member Functions

bool | Freeze () override
| Transitions the object from kStateMutable to kStateFrozen. More...
size_t | SizeOfObject () override
| Returns the amount of space that this object will consume when written to a minidump file, in bytes, not including any leading or trailing padding necessary to maintain proper alignment. More...
std::vector< MinidumpWritable * > | Children () override
| Returns the object’s children. More...
bool | WriteObject (FileWriterInterface *file_writer) override
| Writes the object’s content. More...
MinidumpStreamType | StreamType () const override
| Returns an object’s stream type. More...
Protected Member Functions inherited from crashpad::internal::MinidumpStreamWriter
bool | Freeze () override
| Transitions the object from kStateMutable to kStateFrozen. More...
Protected Member Functions inherited from crashpad::internal::MinidumpWritable
State | state () const
| The state of the object.
virtual size_t | Alignment ()
| Returns the object’s desired byte-boundary alignment. More...
virtual Phase | WritePhase ()
| Returns the object’s desired write phase. More...
size_t | WillWriteAtOffset (Phase phase, FileOffset *offset, std::vector< MinidumpWritable *> *write_sequence)
| Prepares the object to be written at a known file offset, transitioning it from kStateFrozen to kStateWritable. More...
virtual bool | WillWriteAtOffsetImpl (FileOffset offset)
| Called once an object’s writable file offset is determined, as it transitions into kStateWritable. More...
bool | WritePaddingAndObject (FileWriterInterface *file_writer)
| Writes the object, transitioning it from kStateWritable to kStateWritten. More...

## Additional Inherited Members

Protected Types inherited from crashpad::internal::MinidumpWritable
enum | State
| Identifies the state of an object. More...
enum | Phase
| Identifies the phase during which an object will be written to a minidump file. More...
Static Protected Attributes inherited from crashpad::internal::MinidumpWritable
static constexpr size_t | kInvalidSize = std::numeric_limits<size_t>::max()
| A size value used to signal failure by methods that return `size_t`.

## Detailed Description

The writer for a MinidumpCrashpadInfo stream in a minidump file.

## Member Function Documentation

## Children()

std::vector< internal::MinidumpWritable * > crashpad::MinidumpCrashpadInfoWriter::Children | ( |  | ) |

overrideprotectedvirtual

Returns the object’s children.

Note
  Valid in kStateFrozen or any subsequent state.

Reimplemented from crashpad::internal::MinidumpWritable.

## Freeze()

bool crashpad::MinidumpCrashpadInfoWriter::Freeze | ( |  | ) |

overrideprotectedvirtual

Transitions the object from kStateMutable to kStateFrozen.

The default implementation marks the object as frozen and recursively calls Freeze() on all of its children. Subclasses may override this method to perform processing that should only be done once callers have finished populating an object with data. Typically, a subclass implementation would call RegisterRVA() or RegisterLocationDescriptor() on other objects as appropriate, because at the time Freeze() runs, the in-memory locations of RVAs and location descriptors are known and will not change for the remaining duration of an object’s lifetime.

Returns
  `true` on success. `false` on failure, with an appropriate message logged.

Reimplemented from crashpad::internal::MinidumpWritable.

## InitializeFromSnapshot()

void crashpad::MinidumpCrashpadInfoWriter::InitializeFromSnapshot | ( | const ProcessSnapshot * | process_snapshot | ) |

Initializes MinidumpCrashpadInfo based on process_snapshot.

This method may add additional structures to the minidump file as children of the MinidumpCrashpadInfo stream. To do so, it may obtain other snapshot information from process_snapshot, such as a list of ModuleSnapshot objects used to initialize MinidumpCrashpadInfo::module_list. Only data that is considered useful will be included. For module information, usefulness is determined by MinidumpModuleCrashpadInfoListWriter::IsUseful().

Parameters

  [in] | process_snapshot | The process snapshot to use as source data.

Note
  Valid in kStateMutable. No mutator methods may be called before this method, and it is not normally necessary to call any mutator methods after this method.

## IsUseful()

bool crashpad::MinidumpCrashpadInfoWriter::IsUseful | ( |  | ) | const

Determines whether the object is useful.

A useful object is one that carries data that makes a meaningful contribution to a minidump file. An object carrying children would be considered useful.

Returns
  `true` if the object is useful, `false` otherwise.

## SetModuleList()

void crashpad::MinidumpCrashpadInfoWriter::SetModuleList | ( | std::unique_ptr< MinidumpModuleCrashpadInfoListWriter > | module_list | ) |

Arranges for MinidumpCrashpadInfo::module_list to point to the MinidumpModuleCrashpadInfoList object to be written by module_list.

This object takes ownership of module_list and becomes its parent in the overall tree of internal::MinidumpWritable objects.

Note
  Valid in kStateMutable.

## SetSimpleAnnotations()

void crashpad::MinidumpCrashpadInfoWriter::SetSimpleAnnotations | ( | std::unique_ptr< MinidumpSimpleStringDictionaryWriter > | simple_annotations | ) |

Arranges for MinidumpCrashpadInfo::simple_annotations to point to the MinidumpSimpleStringDictionaryWriter object to be written by simple_annotations.

This object takes ownership of simple_annotations and becomes its parent in the overall tree of internal::MinidumpWritable objects.

Note
  Valid in kStateMutable.

## SizeOfObject()

size_t crashpad::MinidumpCrashpadInfoWriter::SizeOfObject | ( |  | ) |

overrideprotectedvirtual

Returns the amount of space that this object will consume when written to a minidump file, in bytes, not including any leading or trailing padding necessary to maintain proper alignment.

Note
  Valid in kStateFrozen or any subsequent state.

Implements crashpad::internal::MinidumpWritable.

## StreamType()

MinidumpStreamType crashpad::MinidumpCrashpadInfoWriter::StreamType | ( |  | ) | const

overrideprotectedvirtual

Returns an object’s stream type.

Note
  Valid in any state.

Implements crashpad::internal::MinidumpStreamWriter.

## WriteObject()

bool crashpad::MinidumpCrashpadInfoWriter::WriteObject | ( | FileWriterInterface * | file_writer | ) |

overrideprotectedvirtual

Writes the object’s content.

Parameters

  [in] | file_writer | The file writer to receive the object’s content.

Returns
  `true` on success. `false` on error, indicating that the content could not be written to the minidump file.

Note
  Valid in kStateWritable. The object will transition to kStateWritten after this method returns.

Implements crashpad::internal::MinidumpWritable.

The documentation for this class was generated from the following files:

- minidump/minidump_crashpad_info_writer.h
- minidump/minidump_crashpad_info_writer.cc